package org.apache.bcel.generic;

import org.apache.bcel.ExceptionConst;
import org.apache.bcel.ExceptionConst.EXCS;

public class PUTFIELD extends FieldInstruction implements PopInstruction, ExceptionThrower {
   PUTFIELD() {
   }

   public PUTFIELD(int index) {
      super((short)181, index);
   }

   public void accept(Visitor v) {
      v.visitExceptionThrower(this);
      v.visitStackConsumer(this);
      v.visitPopInstruction(this);
      v.visitTypedInstruction(this);
      v.visitLoadClass(this);
      v.visitCPInstruction(this);
      v.visitFieldOrMethod(this);
      v.visitFieldInstruction(this);
      v.visitPUTFIELD(this);
   }

   public int consumeStack(ConstantPoolGen cpg) {
      return this.getFieldSize(cpg) + 1;
   }

   public Class<?>[] getExceptions() {
      return ExceptionConst.createExceptions(EXCS.EXCS_FIELD_AND_METHOD_RESOLUTION, new Class[]{ExceptionConst.NULL_POINTER_EXCEPTION, ExceptionConst.INCOMPATIBLE_CLASS_CHANGE_ERROR});
   }
}
